"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.debounceAfter = exports.debounceBefore = void 0;
function debounceBefore(func, timeout = 300) {
    let timer;
    return (...args) => {
        if (!timer) {
            func.apply(this, args);
        }
        clearTimeout(timer);
        timer = setTimeout(() => {
            timer = undefined;
        }, timeout);
    };
}
exports.debounceBefore = debounceBefore;
function debounceAfter(func, timeout = 300) {
    let timer;
    return (...args) => {
        clearTimeout(timer);
        timer = setTimeout(() => {
            func.apply(this, args);
        }, timeout);
    };
}
exports.debounceAfter = debounceAfter;
